'use strict';

var ListaConciliacaoController = angular.module('ListaConciliacaoController', []);

ListaConciliacaoController.controller('ListaConciliacaoCtrl', ['$scope', '$routeParams', '$filter', 'Compra', 'Construcao', 'Fonte', 'Categoria', 'CacheApp',
  ($scope, $routeParams, $filter, Compra, Construcao, Fonte, Categoria, CacheApp) => {

    $scope.getFornecedores = () => {
        var params = {
            IdClienteDono: $scope.sessao.IdClienteAdmin ? $scope.sessao.IdClienteAdmin : $scope.sessao.IdCliente
        };
        Compra.getFornecedores(params,
            (data) => {
                $scope.fornecedores = data.Instance;
            });
    }

    /* override getLista(texto)  */
    $scope.getListaFornecedor = (texto) => {
        $scope.listaFornecedor = $filter('filter')($scope.fornecedores, {RazaoSocial: texto});
    }

    /* override clickAdd()  */
    $scope.novoFornecedor = () => {
    }

    /* override setSelecionado(selecionado)  */
    $scope.setSelecionadoFornecedor = (selecionado, nota) => {
        nota.RazaoSocial = selecionado.RazaoSocial;
        nota.Cnpj = selecionado.Cnpj;
    }

    $scope.novoOfxFile = () => {
        $scope.FonteNFSelecionada = undefined
        $scope.listaOfxFile = [];
        $scope.listaOfx = {
            ValorDebido: 0,
            ValorCredito: 0,
            Saldo: 0,
            Data: []
        }
        $scope.exibirDropZoneOfxFile = false;
        $scope.$apply();
    }

    $scope.blocoOfxFile = () => {

        $scope.listaOfxFile = [];
        document.querySelectorAll(".drop-zone__input").forEach((inputElement) => {
            const dropZoneElement = inputElement.closest(".drop-zone");

            dropZoneElement.removeEventListener("click", (e)=>{})

            dropZoneElement.addEventListener("click", (e) => {
                inputElement.click();
            });

            inputElement.addEventListener("change", (e) => {
                if (inputElement.files.length) {
                    const totImagens = inputElement.files.length;
                    var files = inputElement.files;
                    for (var i = 0; i<totImagens; i++){
                        if ($scope.listaOfxFile.some(c => c.file == files[i]))
                            continue;

                        $scope.listaOfxFile.push({
                            IdFonte: $scope.FonteNFSelecionada.IdFonte,
                            IdClienteDono: $scope.sessao.Admin ? $scope.sessao.IdClienteAdmin : $scope.sessao.IdCliente,
                            Nome: files[i].name, 
                            file: files[i]
                        });
                    }
                    document.getElementById("dropZoneInputXLSX").value = "";

                    $scope.savePlanilha = true;
                    $scope.$apply();
                }
            });

            dropZoneElement.addEventListener("dragover", (e) => {
                e.preventDefault();
                dropZoneElement.classList.add("drop-zone--over");
            });

            ["dragleave", "dragend"].forEach((type) => {
                dropZoneElement.addEventListener(type, (e) => {
                    dropZoneElement.classList.remove("drop-zone--over");
                });
            });

            dropZoneElement.addEventListener("drop", (e) => {
                e.preventDefault();

                if (e.dataTransfer.files.length) {
                    var files = e.dataTransfer.files;
                    const totImagens = files.length;
                    for (var i = 0; i<totImagens; i++){
                        if ($scope.listaOfxFile.some(c => c.file == files[i])
                            || ['ofx'].indexOf(files[i].name.split('.').pop().toLowerCase()) < 0
                        )
                            continue;
                        
                        $scope.listaOfxFile.push({
                            IdFonte: $scope.FonteNFSelecionada.IdFonte,
                            IdClienteDono: $scope.sessao.Admin ? $scope.sessao.IdClienteAdmin : $scope.sessao.IdCliente,
                            Nome: files[i].name, 
                            file: files[i]
                        });
                    }

                    $scope.leituraOfxFile()
                    $scope.$apply();
                }

                dropZoneElement.classList.remove("drop-zone--over");
            });
        }); 
    }

    $scope.leituraOfxFile = () => {
        var item = $scope.listaOfxFile[0];
        const reader = new FileReader();
        reader.onload = (e) => {
            const fileContent = e.target.result;
            var params = {
                IdFonte: item.IdFonte,
                IdClienteDono: $scope.sessao.IdClienteAdmin ? $scope.sessao.IdClienteAdmin : item.IdClienteDono,
                Nome: item.Nome,
                OfxFile: fileContent
            }
            Compra.ConciliaExtratoOfx(params,
                (data) => {
                    $scope.listaOfx = data.Instance
                })
        };
        reader.readAsText(item.file,'utf8');
    }

    $scope.lancaNota = (nota) => {
        nota.concilia = true
        nota.construcoes = $scope.construcoes
    }

    $scope.salvaNota = (nota) => {
        var nf = {
            IdConstrucao: nota.ObraSelecionada.id,
            Tipo: 1,
            TipoPessoa: nota.Valor > 0 ? 0 : 1,
            IdFonte: $scope.FonteNFSelecionada.IdFonte,
            IdCategoria: nota.CategoriaSelecionada ? nota.CategoriaSelecionada.IdCategoria : undefined,
            contabil: 1,
            naoVincula: false,
            Cnpj: nota.Cnpj,
            RazaoSocial: nota.RazaoSocial,
            Numero: null,
            Natureza: nota.Valor > 0 ? 1 : 0,
            DataEmissao: CacheApp.getData(nota.DataHora),
            DataPagamento: CacheApp.getData(nota.DataHora),
            Desconto: 0,
            Valor: nota.Valor < 0 ? -nota.Valor : nota.Valor,
            Descricao: nota.DescricaoNota,
        }

        Compra.setNotaFiscal(nf,
            (data) => {
                Compra.getNotasFiscaisPaginacao({IdConstrucao: nf.IdConstrucao, IdNotaFiscal: data.Instance.IdNotaFiscal},
                    (data) => {
                        nota.NotaFiscal = data.Instance[0]
                        nota.NotaFiscal.Titulo = nota.ObraSelecionada.label
                        nota.concilia = false

                        Compra.salvaLogArquivo(
                            {
                                IdConstrucao: nf.IdConstrucao, 
                                IdClienteDono: $scope.sessao.IdClienteAdmin ? $scope.sessao.IdClienteAdmin : $scope.sessao.IdCliente,
                                Arquivo: 'OFX-CONCILIACAO',
                            },(data) => {})        
                    }
                )
            }
        )

    }

    $scope.descartaNota = (nota) => {
        $scope.listaOfx.Data.splice($scope.listaOfx.Data.indexOf(nota), 1)
    }

    $scope.getListaConstrucao = (callBack) => {
        var params = { 
            Tipo: 0, 
            IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined
        }
        Construcao.getListaObras(params,
            (data) => {
                $scope.construcoes = data.Instance.filter(c => c.Acessos && c.Acessos.indexOf('GET_FINANCEIRO') >= 0)
                callBack()
            }
        );
    }

    $scope.selecionaObra = (nota) => {
        nota.listaFornecedor = $scope.listaFornecedor
        nota.listaCategoriaNF = $scope.listaCategoriaNF
    }

    $scope.getListaCategoriaNF = () => {
        Categoria.getListaCategoria($scope.sessao.IdCliente,
            (data) => {
                $scope.listaCategoriaNF = data.Instance;
                $scope.listaCategoriaNF.unshift({IdCategoria: 0, Nome: 'Sem Categoria'});
            });
    }

    $scope.getListaFonteNF = () => {
        var params = {IdClienteAdmin: $scope.sessao.ContaAdmin ? $scope.sessao.IdClienteAdmin : undefined}
        Fonte.getListaFonte(params,
            (data) => {
                $scope.listaFonteNF = data.Instance;
            });
    }

    $scope.detalharNota = (nota) => {
        if (!nota.detalhe) {
            nota.construcaoSel = $scope.construcoes.find(c => c.Id == nota.NotaFiscal.IdConstrucao)
            nota.NotaFiscal.DataEmissao = CacheApp.getData(nota.NotaFiscal.DataEmissao);
            nota.NotaFiscal.DataPagamento = CacheApp.getData(nota.NotaFiscal.DataPagamento);
            nota.NotaFiscal.DescricaoNF = nota.NotaFiscal.Descricao;
            nota.NotaFiscal.sefaz = true
            nota.NotaFiscal.BDI = nota.NotaFiscal.BDI ? nota.NotaFiscal.BDI.data[0] == 1 : false;

            nota.detalhe = true
            nota.HtmlNotaFiscal = `
                <manternotafiscal 
                    rd-notafiscal="nota.NotaFiscal"
                    rd-obra="nota.construcaoSel"
                    rd-notasfiscais="[]"
                    rd-fornecedor="{}">
                </manternotafiscal>`
        }
        else {
            nota.construcaoSel = null
            nota.detalhe = false
            nota.HtmlNotaFiscal = ''
        }
    };

    $scope.AcessoAndroid($routeParams, (sim) => {
        $scope.sessao = CacheApp.getSessao()

        $scope.listaOfx = {
            ValorDebido: 0,
            ValorCredito: 0,
            Saldo: 0,
            Data: []
        }

        $scope.getListaConstrucao(() => {
            $scope.getListaFonteNF()
            $scope.getListaCategoriaNF()
            $scope.getFornecedores()
            $scope.blocoOfxFile()
        })

    });
  
}]);
